WI-FI REPEATER MODE ON Android
No conozco ninguna herramienta directa, aparte de las aplicaciones de Android (que usan Wi-Fi Direct), que permita usar wi-fi y hotspot al mismo tiempo. Tampoco es una característica estándar introducida en las ROMs personalizadas hasta ahora (AFAIK). Sin embargo, puedes hacerlo manualmente si te sientes cómodo con el uso de la línea de comandos. Pero NO es posible sin Root.
QUÉ SE NECESITA
-
Dispositivo rooteado
-
El dispositivo debe ser compatible con controlador nl80211
Todos los dispositivos más nuevos con chipset Qualcomm MSM lo soportan AFAIK por ejemplo el Redmi Note 4 de Xiaomi (mido) construido con MSM8953 .
El kernel también debe soportar este controlador. Para confirmar:
~# zcat /proc/config.gz | grep CONFIG_CFG80211
CONFIG_CFG80211=y
~# lshw | grep wireless=
configuration: broadcast=yes driver=wcnss_wlan multicast=yes wireless=Qcom:802.11n
-
El dispositivo debe ser compatible con managed
modo y AP
al mismo tiempo.
~# iw phy | grep -iA2 'valid interface combinations'
valid interface combinations:
* #{ managed } <= 3, #{ IBSS, AP } <= 1, #{ P2P-client, P2P-GO } <= 1,
total <= 3, #channels <= 1
Esto significa que su chip inalámbrico admite la creación de un máximo de 3 interfaces, una de las cuales puede estar en AP
modo, mientras que otros están en managed
o P2P
y como máximo 1 canal es compatible. Si el valor de los canales es 2, puede operar ambas interfaces en canales diferentes. Sin embargo, se recomienda utilizar el mismo canal para evitar interferencias.
Interfaz wi-fi estándar en los dispositivos Android (normalmente wlan0
) se ejecuta siempre en managed
modo. Vamos a crear una interfaz inalámbrica virtual para ser ejecutada en AP
modo.
-
Herramientas de Linux: iw
, ip
, iptables
, hostapd
, dnsmasq
etc.
También puede utilizar wpa_supplicant
en lugar de hostapd
con una configuración ligeramente diferente.
Normalmente estos binarios vienen incluidos en Android. Sin embargo, hay modificaciones por parte de Google y los proveedores para hacer que estas herramientas se adapten a las necesidades de Android. Por lo tanto, puede que no se comporten como las herramientas estándar de Linux y, en algunos casos, puede que tenga que compilarlas desde el código fuente.
Las herramientas inalámbricas deben ser lo suficientemente nuevas como para tener soporte para el controlador nl80211
.
-
Emulador de terminal (Termux es uno bueno)
PASOS:
Para facilitar el uso, he resumido todos los pasos en un shell script con una breve explicación. Puedes ponerlo en tu $PATH, por ejemplo /system/bin/android_ap
y ejecutarlo directamente: ~# android_ap start
. A Ajustes rápidos personalizados Las baldosas también pueden ser creado para facilitar su uso.
#!/system/bin/sh
set -e
#set -x
[ "$(id -u)" != 0 ] && echo 'Not running as root!' && exit
SSID=MyAP # set this to your desired string (avoid spaces and non-ascii characters)
PASSCODE=foobarfoobar # set this to your desired string (8 to 63 characters)
WIFI_INTERFACE=wlan0 # set this according to your device (lshw | grep -A10 Wireless | grep 'logical name')
SUBNET=192.168.42 # must be different than WIFI_INTERFACE
AP_INTERFACE=${WIFI_INTERFACE}-AP
IP=${SUBNET}.1
DIR=/data/local/tmp/$AP_INTERFACE
USAGE()
{
echo 'Usage:'
printf '\t%s\n' "$(basename "$0") start|stop"
exit
}
STOP() {
# hope there are no other instances of same daemons
pkill -15 hostapd dnsmasq
# remove iptables rules
iptables -D INPUT -i $AP_INTERFACE -p udp -m udp --dport 67 -j ACCEPT
iptables -t nat -D POSTROUTING -s ${SUBNET}.0/24 ! -o $AP_INTERFACE -j MASQUERADE
iptables -D FORWARD -i $AP_INTERFACE -s ${IP}/24 -j ACCEPT
iptables -D FORWARD -i $WIFI_INTERFACE -d ${SUBNET}.0/24 -j ACCEPT
# delete AP interface
ip link show | grep "${AP_INTERFACE}:" && iw $AP_INTERFACE del
rm -rf $DIR
} >/dev/null 2>&1
CHECKS()
{
for binary in iw ip iptables hostapd dnsmasq; do
which $binary >/dev/null && continue
exit
done
# this check is necessary if need to use single channel
if iw dev $WIFI_INTERFACE link | grep -q '^Not connected'
then
echo 'First connect to Wi-Fi for internet sharing.'
exit
fi
if ! iw phy | grep -iqE '{.*managed.*AP.*}' && ! iw phy | grep -iqE '{.*AP.*managed.*}'
then
echo 'AP mode not supported.'
exit
fi
}
CREATE_AP()
{
if ! iw dev $WIFI_INTERFACE interface add $AP_INTERFACE type __ap
then
echo "Couldn't create AP." # :(
exit
fi
}
FIND_CHANNEL()
{
# find what channel wi-fi is using
CHANNEL="$(iw $WIFI_INTERFACE scan | grep -C5 "$(iw $WIFI_INTERFACE link | grep SSID | cut -d: -f2-)" | grep -i channel | tail -c3)"
if [ -z "$CHANNEL" ]
then
echo "Couldn't find channel info. Are you are connected to Wi-Fi?"
STOP
exit
fi
# if more than 1 channels are supported, use any frequency
[ ! -z "$CHANNEL" ] || CHANNEL=11
}
ADD_IP_ROUTE()
{
# activate the interface and add IP
ip link set up dev $AP_INTERFACE
ip addr add ${IP}/24 broadcast ${SUBNET}.255 dev $AP_INTERFACE
# routing table 97 needs to be put necessarily on Android
# because in main table, route for $WIFI_INTERFACE takes priority (ip route show)
# and all traffic goes there ignoring $AP_INTERFACE
ip route add ${SUBNET}.0/24 dev $AP_INTERFACE table 97
}
HOSTAPD_CONFIG()
{
mkdir -p "$DIR"
cat <<-EOF >$DIR/hostapd.conf
# network name
ssid=$SSID
# network interface to listen on
interface=$AP_INTERFACE
# wi-fi driver
driver=nl80211
# WLAN channel to use
channel=$CHANNEL
# ser operation mode, what frequency to use
hw_mode=g
# enforce Wireless Protected Access (WPA)
wpa=2
# passphrase to use for protected access
wpa_passphrase=$PASSCODE
# WPA protocol
wpa_key_mgmt=WPA-PSK
EOF
# you can tune other parameters such as mtu, beacon_int, ieee80211n, wowlan_triggers (if supported)
# for better performace and options such as *_pairwise for better security
}
INTERNET_SHARE()
{
# allow IP forwarding
echo 1 >/proc/sys/net/ipv4/ip_forward
# route and allow forwrding through firewall
iptables -t nat -I POSTROUTING -s ${SUBNET}.0/24 ! -o $AP_INTERFACE -j MASQUERADE
iptables -I FORWARD -i $AP_INTERFACE -s ${IP}/24 -j ACCEPT
iptables -I FORWARD -i $WIFI_INTERFACE -d ${SUBNET}.0/24 -j ACCEPT
}
DHCP_SERVER()
{
# configuration
cat <<-EOF >$DIR/dnsmasq.conf
# we dont want DNS server, only DHCP
port=0
# only listen on AP interface
interface=$AP_INTERFACE
listen-address=$IP
#bind-interfaces
# range of IPs to make available to wlan devices andwhen to renew IP
dhcp-range=$IP,${SUBNET}.254,24h
# where to save leases
dhcp-leasefile=$DIR/dnsmasq.leases
# set default gateway
dhcp-option-force=option:router,$IP
# add OpenDNS servers for DNS lookup to announce
dhcp-option-force=option:dns-server,208.67.220.220,208.67.222.222
#dhcp-option-force=option:mtu,1500
# respond to a client who is requesting from a different IP broadcast subnet
# or requesting an out of range / occupied IP
# or requesting an IP from expired lease of previous sessions
# or obtained from some other server which is offline now
dhcp-authoritative
# don't look for any hosts file and resolv file
no-hosts
no-resolv
EOF
# open listening port
iptables -I INPUT -i $AP_INTERFACE -p udp -m udp --dport 67 -j ACCEPT
# start dhcp server
dnsmasq -C $DIR/dnsmasq.conf
}
if [ "$1" = stop ]
then
STOP || true
exit
fi
[ "$1" = start ] || USAGE
# basic check
CHECKS
# stop running instances
STOP || true
# create virtual wireless interface
CREATE_AP
# find channed already used ny wi-fi
FIND_CHANNEL
# configre newly created interface
ADD_IP_ROUTE
# configure acces point daemon
HOSTAPD_CONFIG
# start hostapd
hostapd -B $DIR/hostapd.conf
# share internet from Wi-Fi to AP
INTERNET_SHARE
# run a dhcp server to assign IP's dynamically
# otherwise assign a static IP to connected device in subnet range (2 to 254)
DHCP_SERVER
echo Done.
FUENTES:
0 votos
Relacionado: Android como puente WiFi con AP
1 votos
Esto está relacionado con AOSP7 que es bastante antiguo. En Android 11 en mi Pixel 3A, y mi Pixel 5 ambos admiten la conexión a datos móviles a través de Wi-Fi y la transmisión del hotspot de la ruta predeterminada, al mismo tiempo.